#===========================
# This function should be customized by students
#
#   F(x,y):
# Takes coordinates of a point (two float values)
# returns True/False - is that point belong to the coloured area
#===========================

def F(x,y):
    return (abs(y)>x*x) and (y<5) or (x**2+(y-6.5)**2<2.25)

#===========================

from tkinter import *

def Paint(XYrange, CV):
        # destroy previous graphical contents to release resources
        # (TkInter specific behaviour)
        #
    CV.delete("all")
    
        # choose w(idth) and h(eight) so that to paint the squadric area
    w = min(int(canv["width"]), int(canv["height"]))
    h = w
    Xo = w//2
    Yo = h//2
    
        # choose dx,dy
    dx = min(XYrange/Xo, XYrange/Yo)
    dy = dx
    
        # iterate through all points of the plotted area
        # paint points for those f(x,y) returned True
        #
    for ys in range(h):
        y = (Yo-ys)*dy
        x0 = 0
        f1 = False
        for xs in range(w+1):
            if xs>=w:
                f2 = False
            else:
                x = (xs-Xo)*dx
                f2 = F(x,y)
            
            if not f1 and f2:
                x0 = xs
            elif f1 and not f2:
                CV.create_line(x0, ys, xs, ys)
                x0 = xs
            f1 = f2

        # draw OX and OY axes
    CV.create_line(0, Yo, w, Yo, fill="red")
    CV.create_line(Xo, 0, Xo, h, fill="red")
        
        # draw auxiliary markup
    for z in range(1,XYrange,1):
        xs = int(z/dx)
        ys = int(z/dy)
        CV.create_line(0, Yo+ys, w, Yo+ys, fill="red", dash=(4,4))
        CV.create_line(0, Yo-ys, w, Yo-ys, fill="red", dash=(4,4))
        CV.create_line(Xo+xs, 0, Xo+xs, h, fill="red", dash=(4,4))
        CV.create_line(Xo-xs, 0, Xo-xs, h, fill="red", dash=(4,4))
        
    # end od work!!
    return

#===========================


root = Tk()
root.title("Logic Areas")
root.minsize(300, 300)
root.resizable(width=True, height=True)

frmMain = Frame(root, borderwidth=0, relief=FLAT)   # RAISED
frmMain.pack(fill=BOTH, expand=YES)

frmParams = Frame(frmMain, borderwidth=0, relief=FLAT)
frmParams.pack(side=TOP, expand=NO)

    #label
lb = Label(frmParams, text="Scale:")
lb.pack(side=LEFT)

    # input field for range ±x, ±y
rng=StringVar()
txt = Entry(frmParams, width=5, textvariable=rng)
txt.pack(side=LEFT)
rng.set("10")


#===========================
def doPaint(event):
    Paint(int(rng.get()), canv)
    return
#===========================


    # Repaint button
btn = Button(frmParams, width=7, text="Repaint")
btn.pack(side=LEFT)
btn.bind("<ButtonPress-1>", doPaint)


    # drawing area
canv = Canvas(frmMain, borderwidth=0, relief=SUNKEN, highlightthickness=0)   # SUNKEN RAISED width=250, height=250,
canv.pack(fill=BOTH, expand=YES)


#===========================
def onResize(event):
    canv["width"] = event.width
    canv["height"] = event.height
    Paint(int(rng.get()), canv)
    
canv.bind("<Configure>", onResize)
#===========================


    # 1-st paint
Paint(int(rng.get()), canv)

# ...
root.mainloop()

